
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>
#include <fnmatch.h>
#include "readconf.h"
#include "lib.h"
#include "linksinfo.h"
#include "answer.h"
#include "sendmail.h"

#define  FNM_CASEFOLD	(1<<4)

Forward(char *request,link_info *link)
{


 FILE *linksfile;
 link_info  uplink;
 int cnt=0;


 log( 2, "Processing forward operation for %s",link->ftn_addr );
 log( 3, "search echo %s in uplink's forwardfiles",request);

 if( ( linksfile = fopen( conf.LinksFile, "r" ) ) == NULL )
  {
   log(0, "Error! Cannot open links file %s",conf.LinksFile );
   exit( 1 );
  }

 while ( GetLinksInfo(&uplink,linksfile) ) //   EOF
  {
   log(4,"Forward: check %s",uplink.ftn_addr);
   cnt=cnt+
    DoUplink(request,&uplink,link);
  }

 fclose(linksfile);
 return(cnt);
 
};


DoUplink (char *request,link_info *uplink,link_info *link)
{

 FILE *ff;
 char str[CHAR_MAX];
 char *word;

 if (uplink->forwardfile[0] == ' ')
  return(1);

 log(3,"try %s from %s",uplink->forwardfile,uplink->ftn_addr);
 
 if( ( ff = fopen(uplink->forwardfile, "r" ) ) == NULL )
  {
   log( 2, "forward file \"%s\" of %s cannot be opened!",uplink->forwardfile,uplink->ftn_addr );
   return(2);
  }
 
 if ( uplink->level[0] > link->level[0] )
  {
   log(2,"%s has not access to request from %s",link->ftn_addr,uplink->ftn_addr);
   return(3);
  }

 while( fgets( str, CHAR_MAX, ff ) != NULL ) //read uplink's forwardfile
  {
   strtok (str,"\r\n");
   word = strtok (str," \t") ; // take areaname

   log(5,"forward: search echo:\"%s\" processing word \"%s\"",request,word);
		
   //the echo that we need exist it uplink's forwardfile
   //         if ( ! strcasecmp(echo,word) )
   if ( (word != NULL ) && (! fnmatch (request,word,FNM_CASEFOLD )) )
    {	
     log(5,"forward: found echo: %s",word);
     CreateEcho(word,uplink,link);
    }
  }

 fclose(ff);
 return(0);
}
     

CreateEcho(char *echoname,link_info *uplink,link_info *link)
{
 char tmpname[PATH_MAX];
 char tmecho[MAXSTR+1];
 char echo[MAXSTR+1];
 char tmpstr[CHAR_MAX];
 char fadr[ftnsize+1];
 int pid,len,elen;

 int ei,ti;
 
 FILE *areafile;
 FILE *tf;

 pid=getpid();
 ei=0;ti=0;

 log(4,"CreateEcho: link %s, uplink %s, echo %s",
     link->ftn_addr,uplink->ftn_addr,echoname);
 
 sprintf(tmpname,"%s.affwdtmp%d",conf.AreaFile,pid);
 copy(conf.AreaFile,tmpname);

 if (uplink->domain_addr[0] == ' ')
  Ftn2Domain(uplink->ftn_addr,uplink->domain_addr);
 
 OpenMail(uplink->uareafix,uplink,uplink->upasswd);
 OpenMail(link->name,link,SUBSCRIBERESULT);

 if ( ExistEcho(echoname,uplink,link) == 1) //not found in areas.bbs
  {

   log(4,"CreateEcho: echo not exist in areas.bbs, create it..");
   if( ( tf = fopen( tmpname, "a" ) ) == NULL )
    {
     log( 0, "tmpfile \"%s\" cannot open tmpfile!", tmpname );
     exit( 1 );
    }

   echo[0]='\0';
   len=strlen(conf.Template);
   elen=strlen(echoname);
 
   while (ti <= len)
    {

     if ((conf.Template[ti] == '$') && ((ti) < len ) )
      {
       switch (conf.Template[ti+1])
        {
        case 'N':
         ti=ti+2;
         strcat(echo,echoname);
         ei=strlen(echo);
         break;
        case 'L':
         ti=ti+2; //skip "$L"
         strcat(echo,uplink->level);
         ei=strlen(echo);
         break;
        default:
         echo[ei]=conf.Template[ti];
         echo[ei+1]='\0';
         ei++;ti++;
        }
      }
     else
      {
       echo[ei]=conf.Template[ti];
       echo[ei+1]='\0';
       ei++;ti++;
      }
    }

   sprintf(fadr,"z");
 
   if ( strcmp(uplink->zone,link->zone) )
    strcpy(fadr,link->ftn_addr);
   if ( (fadr[0] == 'z' ) && ( strcmp(uplink->net,link->net)) )
    sprintf(fadr,"%s/%s",link->net,link->node);

   if ( (fadr[0] == 'z' ) && ( strcmp(uplink->node,link->node)) )
    sprintf(fadr,"%s",link->node);

   if ( link->point[0] != '0' )
    {
     sprintf(tmpstr,"%s.%s",fadr,link->point);
     strcpy(fadr,tmpstr);
    }

   sprintf(tmpstr,"%s %s %s",echo,uplink->ftn_addr,fadr);
   strcpy(echo,tmpstr);

   log(4,"CreateEcho: got result echo:  '%s'",echo);

   fprintf(tf,"%s\n",echo);
   fclose(tf);

   rename(tmpname,conf.AreaFile);

  }

 sprintf(tmpstr,"found at %s, %s %s\n",uplink->ftn_addr,SUBSCRIBED,echoname);
 AddMail(link,tmpstr);

 sprintf(tmpstr,"+%s",echoname);
 AddMail(uplink,tmpstr);
 
 log(2,"%s requested from %s",echoname,uplink->ftn_addr);
 log(2,"%s subscribed to %s",link->ftn_addr,echoname);

 CloseMail(uplink);
 CloseMail(link);

}


SendAvail(link_info *link)
{

 FILE *linksfile;
 link_info  uplink;

 log( 2, "Processing %avail operation for %s",link->ftn_addr );
 
 if( ( linksfile = fopen( conf.LinksFile, "r" ) ) == NULL )
  {
   log(0, "Error! Cannot open links file %s",conf.LinksFile );
   exit( 1 );
  }

 OpenMail(link->name,link,AVAILREQUEST);
 
 while ( GetLinksInfo(&uplink,linksfile) ) //   EOF
  {
   log(4,"SendAvail: check %s",uplink.ftn_addr);
   log(5,"SendAvail: forwardfile: %s",uplink.forwardfile);

   if ( (uplink.level[0]<=link->level[0]) &&
        (uplink.forwardfile[0] != ' ') )
    AddToList(&uplink,link);
  }

 fclose(linksfile);

 CloseMail(link);
  
}



AddToList(link_info *uplink, link_info *link)
{

 FILE *ff;
 char str[CHAR_MAX];


 log(4,"AddToList: try %s from %s",uplink->forwardfile,uplink->ftn_addr);
 
 if( ( ff = fopen( uplink->forwardfile, "r" ) ) == NULL )
  {
   log(0, "Error! Cannot open  forwardfile %s",uplink->forwardfile);
   return( 1 );
  }

 sprintf(str,"\n From %s:",uplink->ftn_addr);
 AddMail(link,str);
 
 while( fgets( str, CHAR_MAX, ff ) != NULL ) //read areas file
  {
   strtok (str,"\n\r");
   AddMail(link,str);
  }

 fclose(ff);
}


ExistEcho(char *echoname, link_info *uplink,link_info *link )
{

 FILE *af;
 FILE *tf;

 char tmpname[PATH_MAX];
 char echo[MAXSTR+1];

 int pid,n=1;

 log(4,"ExistEcho: find echo %s in areas file..",echoname);
 
 pid=getpid();

 sprintf(tmpname,"%s.afcrtstmp%d",conf.AreaFile,pid);

 if( ( af = fopen( conf.AreaFile, "r" ) ) == NULL )
  {
   log( 0, "AreaFile \"%s\" cannot be opened!", conf.AreaFile );
   exit( 1 );
  }

 if( ( tf = fopen( tmpname, "w" ) ) == NULL )
  {
   log( 0, "tmpfile \"%s\" cannot be created!", tmpname );
   exit( 1 );
  }

 while( fgets( echo, MAXSTR, af ) != NULL ) //read areas file
  {
   strtok (echo,"\n\r");

   if ( CheckOldEcho(echo,echoname,uplink,link) == 0 )
    n=0; //echo found.

   fprintf(tf,"%s\n",echo);
  }


 fclose(tf);
 fclose(af);
 
 if (! n)
  rename(tmpname,conf.AreaFile);
 else
  remove(tmpname);
    
 return(n);
 
}; //find in areas.bbs, if exist - subscr uplink,link
//not - return 1


CheckOldEcho(char *str, char *echoname, link_info *uplink,link_info *link )
{
 char newstr[CHAR_MAX];
 char *word;

 log(5,"CheckOldEcho: instr '%s'",str);
 log(5,"    echoname '%s', uplink %s link %s",echoname,uplink->ftn_addr,link->ftn_addr);
 
 strcpy(newstr,str);

 word=strtok(newstr," \t");

 if ( strcasecmp("EchoArea",word) )
  return (2);

 word=strtok(NULL," \t");

 if ( strcasecmp(echoname,word) )
  return (3);


 strcat(str," ");
 strcat(str,uplink->ftn_addr);
 strcat(str," ");

 if ( strcmp(link->zone,uplink->zone) )
  {
   strcat(str,link->ftn_addr);
   log(4,"CheckOldEcho: outstr=%s",str);
   return (0);
  }

 if ( strcmp(link->net,uplink->net) )
  {
   strcat(str,(link->ftn_addr+strlen(link->zone)+1));
   log(4,"CheckOldEcho: outstr=%s",str);
   return (0);
  }

  
 if ( strcmp(link->node,uplink->node) )
  {
   strcat(str,
          (link->ftn_addr+strlen(link->zone)+1+strlen(link->net)+1));
   log(4,"CheckOldEcho: outstr=%s",str);
   return (0);
  }

 strcat(str,".");
 strcat(str,link->point);

 log(4,"CheckOldEcho: outstr=%s",str);
 return (0);
}
