#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "limits.h"
#include "lib.h"
#include "log.h"
#include "readconf.h"

ReadConfig(char *configfile)
{
 FILE *cfgfl;
 int c;
 char buf[CHAR_MAX];
 char comm[20];
 char param[PATH_MAX];
 
 if( ( cfgfl = fopen( configfile, "r" ) ) == NULL )
  {
   printf( "Error! Cannot open config file %s",configfile );
   exit( 1 );
  }
 
 while( fgets( buf, CHAR_MAX, cfgfl ) != NULL )
  {
   if( strlen( buf ) > 2 && buf[0] != '#' )
    {
     sscanf( buf, "%s%*[ \t]%[A-Za-z0-9'`*.,#/%<>-+=_\()|:$ ]",
             &comm, &param );
     c = FoundComm( comm );

     //     printf("c=%d,param=%s\n",c,param);

     switch( c )
      {
      case 0: strcpy( conf.SysOp, param );
       break;
      case 1: strcpy( conf.Address, param );
       break;
      case 2: strcpy( conf.Robot_Name, param );
       break;
      case 3:
       if( tolower( param[0] ) == 'y' )
        conf.Forward = 1;
       else
        conf.Forward = 0;
       break;
      case 4:
       c=param+1;
       param[strlen(param)]='\0';
       strncpy( conf.Template,c,strlen(param)-2 );
       break;
      case 5: strcpy( conf.MailCommand, param );
       break;
      case 6: conf.LogLevel = atoi( param );
       break;
      case 7: strcpy( conf.LinksFile, param );
       break;
      case 8: strcpy( conf.HelpFile, param );
       break;
      case 9: strcpy( conf.AreaFile, param );
       break;
      case 10: strcpy( conf.logfile, param );
       break;
      case 11:
       if( tolower( param[0] ) == 'y' )
        conf.KillEmpty = 1;
       else
        conf.KillEmpty = 0;
       break;
      }
    }
  }

 fclose (cfgfl);

}

FoundComm(char *command)
{
 int i=0;
 while( i++ != MAXCONF )
  {
   strlwr( command );
   if( strcmp( command, CONFCOMM[i-1] ) == 0 )
    return( i-1 );
  }
 return( -1 );
}

