#include <stdio.h>
#include <limits.h>
#include <string.h>
#include "readmsg.h"
#include "linksinfo.h"
#include "commands.h"
#include "limits.h"
#include "readconf.h"

extern char ReadMsgs( link_info *link, char *pass);


char ReadMsgs( link_info *link, char *pass )
{

 char str[CHAR_MAX];


 while( fgets( str, CHAR_MAX, stdin ) != NULL )
  {

   strtok( str, "\n" );
   switch ( str[0] )
    {
    case 'S':
     if( ! strncmp( str, "Subject: ", 9 ) ) 
      TakePass(str,pass);
     break;
    case 'F':
     if( ! strncmp( str, "From: ", 6 ) )
      TakeFrom(str,link);
     break;
    case '%': 
    case '+': 
    case '-': 
     if ( ! TakeCommand(str) )
     return (1);
    }
  }

 return (0);
};


TakePass(char *str,char *pass)
{
 char *pword;

 log(4,"TakePass: str %s",str);

 pword=strtok(str," ");
 pword=strtok(NULL," ");

 strcpy(pass,pword);
 
 log(4,"TakePass: pass %s",pass);

};



TakeFrom(char *str,link_info *link)
{

 char fbuf[CHAR_MAX];

 int slen,tf0=0,tf1=0;

 log(4,"TakeFrom: str %s",str);
 
 slen=strlen(str);

 while ( str[slen--] != '>' )
  if ( slen == 0 )
   return;
 
 while ( str[slen] != '@' )
  {
   if ( slen < 0 )
    return;

   //   printf("%c",str[slen]);
   fbuf[tf0++]=str[slen--];
  }

 tf0--;
 slen--;
 
 // printf("\n");

 while ( tf0 >= 0 )
  link->domain_addr[tf1++]=fbuf[tf0--];
 
 link->domain_addr[tf1]='\0';
 
 log(4,"TakeFrom: link->domain_addr %s",link->domain_addr);
 
 tf0=0;tf1=0;
 while ( str[slen] != '<' )
  {
   if ( slen == 0 )
    return;
   
   fbuf[tf0++]=str[slen--];
  }

 tf0--;
 
 while ( tf0 >= 0 )
  link->name[tf1++]=fbuf[tf0--];

};

char TakeCommand( char *str)
{

 int c;
 
 log(4,"TakeCommand: str %s",str);

 strlwr( str );

 switch ( str[0] )
  {
  case '%':
   c = WhatComm( str );
   if( c == -1 )
    {
     log( 1, "unknown command \"%s\"", str );
     return;
    }
   if ( ! AddCmd(c," ") )
    return (1);
   break;
  case '+':
   str++;
   if ( ! AddCmd(5,str) )
    return (1);
   break;
  case '-':
   str++;
   if ( ! AddCmd(6,str) )
    return (1);
   break;
  default:
   log( 1, "unknown command \"%s\"", str );
  }

  return (0);
};


char WhatComm(char* command)
{
	int i=0;

	if( command[0] != '%' ) return( -1 );

	log( 4, "WhatComm: Read command string \"%s\"", command );

	while( i++ != MAXCOMM )
	{
		if( strstr( command, COMMAND[i-1] ) != 0 )
			return( i-1 );
	}
	return( -1 );
}
