#include <limits.h>
#include <stdio.h>
#include "linksinfo.h"
#include "limits.h"
#include "readconf.h"
 
struct mailq {
 char subj[MAXSUBJ];
 char ftnadr[ftnsize+1];
 char msgfile[PATH_MAX];
 struct mailq *nextl;
};

typedef struct mailq mq;

static mq *mails=NULL;


// -         subj,
//  -  


OpenMail(char *to,link_info *link,char *subj)
{
 mq *mptr;
 FILE *mf;
 char tmpname[PATH_MAX];

 mptr=mails;

 log(4,"OpenMail: link: %s, subj: %s",link->ftn_addr,subj);
 
 while ( mptr != NULL )
  {
   log(5,"  Found msg '%s' for %s ",mptr->subj,mptr->ftnadr);
       
   if ( (! strcmp(mptr->subj,subj) ) &&
        ( ! strcmp (mptr->ftnadr,link->ftn_addr) ) )
    {

     log(5,"  Found !  msgfile  %s  ",mptr->msgfile);
     
     if( ( mf = fopen( mptr->msgfile, "a" ) ) == NULL )
      {
       log( 0, "msgfile \"%s\" cannot be opened!", mptr->msgfile );
       exit( 1 );
      }
     
     link->currmsg=mf;
     return (0);
    }

   mptr=mptr->nextl;
  }

 mptr=malloc( sizeof(mq) );
 if ( mptr == NULL )
  {
   printf("Aahgr! not enought memory!,exit");
   log(0,"Aahgr! not enought memory!,exit");
   exit (1);
  }

 tmpnam(tmpname);
 
 if( ( mf = fopen( tmpname, "w" ) ) == NULL )
  {
   log( 0, "msgfile \"%s\" cannot be created!", tmpname );
   exit( 1 );
  }

 strcpy(mptr->subj,subj);
 strcpy(mptr->ftnadr,link->ftn_addr);
 strcpy(mptr->msgfile,tmpname);
 mptr->nextl=mails;

 mails=mptr;

 log(4,"OpenMail: Created record '%s', for '%s'", mptr->subj,mptr->ftnadr);
 log(4," mail file: %s", tmpname);
 
 link->currmsg=mf;

 // printf("adr=%s\n",link->domain_addr);
 BeginMail(to,link->domain_addr,subj,mf);
 return(0);
 
};


AddMail(link_info *link,char *msg)
{

 fprintf(link->currmsg,"%s\n",msg);

};



RemoveMail(link_info *link,char *subj)
{
 mq *mptr0,*mptr1;

 mptr0=mails;
 mptr1=mptr0;
 
 log(4,"RemoveMail: link: %s, subj: %s",link->ftn_addr,subj);
 
 while ( mptr0 != NULL )
  {
   log(5,"  Found msg '%s' for %s ",mptr0->subj,mptr0->ftnadr);
       
   if ( (! strcmp(mptr0->subj,subj) ) &&
        ( ! strcmp (mptr0->ftnadr,link->ftn_addr) ) )
    {
     log(5,"  Found !  msgfile  %s  ",mptr0->msgfile);

     remove(mptr0->msgfile);
     mptr1->nextl=mptr0->nextl;

     log(4,"RemoveMail: removed msg '%s' for %s ",mptr0->subj,mptr0->ftnadr);

     free(mptr0);
     
     return (0);
     
    }
   
   mptr1=mptr0;
   mptr0=mptr0->nextl;
  }

 return (0);

};



CloseMail(link_info *link)
{

 fclose (link->currmsg);
 
};



SendMails()
{
 mq *mptr0,*mptr1;

 mptr0=mails;
 mptr1=mptr0;
 
 log(4,"SendMails: start sending mails");
 
 while ( mptr0 != NULL )
  {
   log(5,"  Found msg '%s' for %s ",mptr0->subj,mptr0->ftnadr);
   log(5,"  Found !  msgfile  %s, sending..",mptr0->msgfile);

   EndMail(mptr0->msgfile);
   SendMail(mptr0->msgfile);

   mptr1=mptr0->nextl;
   
   remove(mptr0->msgfile);
   free(mptr0);

   mptr0=mptr1;
   
  }

 return (0);
 
};


/*		   				*/
BeginMail(char *Name, char *Addr, char *Subj, FILE *f)
{
	fprintf( f, "From: %s@%s\n", conf.Robot_Name, conf.Address );
	fprintf( f, "To: %s@%s\n", Name, Addr );
    //    printf("BeginMail: Addr=%s\n",Addr);
	fprintf( f, "Subject: %s\n\n", Subj );
}


/*		   				*/
EndMail( char *filename)
{

 FILE *ff;

 if( ( ff = fopen( filename, "a" ) ) == NULL )
  {
   log( 0, "msgfile \"%s\" cannot be opened!", filename );
   return( 1 );
  }

 fprintf(ff,"\n\n--- AreaFix v.%s/%s %s (%s)\n\n",
         VER, DATE, conf.SysOp, conf.Address );

 fclose(ff);
}



SendMail(char *File)
{
	char comm[PATH_MAX];

	if( conf.MailCommand[0] == '>' || conf.MailCommand[0] == '|' )
	{
		snprintf( comm, PATH_MAX, "%s %s %s",
				CAT, File, conf.MailCommand );
		log( 5, "Exec: \"%s\"", comm );
		system( comm );
	}
	else
	{
		log( 0, "Error MailCommand \"%s\"", conf.MailCommand );
		return( -1 );
	}

	return( 0 );
}
