
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>
#include <fnmatch.h>
#include "readconf.h"
#include "lib.h"
#include "linksinfo.h"
#include "answer.h"
#include "sendmail.h"

#define  FNM_CASEFOLD	(1<<4)

char UnSubscribe (char *reqstr,link_info *link)
{

 FILE *af;
 FILE *tf;

 char tmpname[PATH_MAX];
 char tmpstr[CHAR_MAX];
 char echo[MAXSTR+1];
 char echoname[MAXLENECHO+1];
 int pid,ch;
 
 link_info uplink;

 pid=getpid();

 sprintf(tmpname,"%s.afunsubstmp%d",conf.AreaFile,pid);
 
 if( ( af = fopen( conf.AreaFile, "r" ) ) == NULL )
  {
   log( 0, "AreaFile \"%s\" cannot be opened!", conf.AreaFile );
   exit( 1 );
  }

 if( ( tf = fopen( tmpname, "w" ) ) == NULL )
  {
   log( 0, "tmpfile \"%s\" cannot be created!", tmpname );
   exit( 1 );
  }

 log (3, "UnSubscribe: request %s area.. ",reqstr);
 log(3,"process request from %s",link->ftn_addr);

 pid=0;

 OpenMail(link->name,link,UNSUBSCRIBERESULT);
  
 while( fgets( echo, MAXSTR, af ) != NULL ) //read areas file
  {
   strtok (echo,"\n\r");
  
   log (4, "UnSubscribe: got string: '%s'",echo);

   ch=UnCheckEcho(echo,reqstr,echoname,link,&uplink);

   log(4,"UnCheckEcho: return code %d",ch);
   
   switch ( ch )
    {
    case 3: //last link, echo removed
     printf("a %s\n",uplink.ftn_addr);
     Ftn2Domain(&uplink.ftn_addr,&uplink.domain_addr);
     printf("a %s\n",uplink.ftn_addr);
     FindLink(&uplink);
     printf("a %s\n",uplink.ftn_addr);
     OpenMail(&uplink.uareafix,&uplink,&uplink.apasswd);
     sprintf(tmpstr,"-%s",echoname);
     AddMail(&uplink,tmpstr);
     CloseMail(&uplink);
     RemoveLastLink(echo);
     log(2,"unsubscribe %s from %s",echoname,uplink.ftn_addr);
    case 0: //just unsubscribed 
     pid++;
     sprintf(tmpstr,"%s %s",echoname,UNSUBSCRIBED);
     AddMail(link,tmpstr);
     log(2,"%s unsubscribed from %s",link->ftn_addr,echoname);
     break;
    case 1:
     pid++;
     sprintf(tmpstr,"%s %s",ECHODISABLED,echoname);
     AddMail(link,tmpstr);
     log(2,"%s has not access to %s",link->ftn_addr,echoname);
     break;
    case 2:
     pid++;
     sprintf(tmpstr,"%s %s",NOTLINKED,echoname);
     AddMail(link,tmpstr);
     log(2,"%s not linked to %s",link->ftn_addr,echoname);
     break;
    default:
    }

   if ( ch != 3 )
    if ( (fprintf(tf,"%s\n",echo)) <0 )
     {
      log(0,"unable to write file %s, aborted!",tmpname);
      exit(1);
     }
   
  }

 fclose(af);
 fclose(tf);

 log(3,"unsubscribe: %d echoes processed for %s",pid,link->ftn_addr);

 //pid == 0 - no echoes found
 
 if ( pid == 0 )
  {
   sprintf(tmpstr,"%s not found",reqstr);
   AddMail(link,tmpstr);
   remove(tmpname);
  }
 else
  rename(tmpname,conf.AreaFile);

 sprintf(tmpstr,"unsubscribe: %d echoes processed for %s",pid,link->ftn_addr);
 AddMail(link,tmpstr);

 CloseMail(link);
 return (pid);
}



UnCheckEcho(char *echo,char *request, char *ename,link_info *link, link_info *uplink)
{
 char tmecho[MAXSTR+1];
 char tm2echo[MAXSTR+1];
 char *cword;

 char defzone[maxels+1];
 char defnet[maxels+1];
 char defnode[maxels+1];

 char zone[maxels+1];
 char net[maxels+1];
 char node[maxels+1];
 char pnt[maxels+1];

 char fadr[ftnsize+1];
 char level[4];
 char uf=0;

 int lcnt=0;
 
 strcpy(tmecho,echo);

 log(5,"UnCheckEcho: tmecho=%s",tmecho);
 
 cword=strtok(tmecho," \t"); //get EchoArea cword

 if ( strcasecmp(cword,"EchoArea") )
  {
   log(3,"CheckEcho: got strange cword: %s, skipping line",cword);
   return (255);
  }
 
 cword=strtok(NULL," \t"); //get echoname

 if ( cword == NULL ) return(250);
 
 if ( fnmatch (request,cword,FNM_CASEFOLD ) ) 
 {
  log(4,"CheckEcho: got echo: %s, search echo: %s skipping line",cword,request);
  return (253);
 }

 strcpy(ename,cword);

 sprintf(tm2echo,"EchoArea %s",ename);

 //search uplink addr & level info
 cword=strtok(NULL," \t"); //get echoname
 
 while ( cword != NULL )
  {
   if ( (strlen(cword) >= 3 ) && (cword[0]=='-') && (cword[1]=='$') && (cword[2]=='l') )
    {
     strncpy(level,cword+3,3);
     if (link->level[0] <= level[0] )
      return (1);
    }
   
   // 356.5 .4 595.1 .8 .11 ;
   strcat(tm2echo," ");
   strcat(tm2echo,cword);

   if ( isdigit(cword[0]) )
    {
     word2addr(cword,zone,net,node,pnt);
     strcpy(uplink->ftn_addr,cword);

     strcpy(defzone,zone);
     strcpy(defnet,net);
     strcpy(defnode,node);

     cword=strtok(NULL," \t");
     break;
    }
      
   cword=strtok(NULL," \t");
  }
 
 while ( cword != NULL )
  {

   if ( (isdigit(cword[0])) || (cword[0]=='.'))
    {
     word2addr(cword,zone,net,node,pnt);

     if ( zone[0]=='z')
      strcpy(zone,defzone);
     else
      strcpy(defzone,zone);

     if (net[0]=='n')
      strcpy(net,defnet);
     else
      strcpy(defnet,net);

     if (node[0]=='f')
      strcpy(node,defnode);
     else
      strcpy(defnode,node);

     sprintf(fadr,"%s:%s/%s.%s",defzone,defnet,defnode,pnt);

     if ( strcmp(fadr,link->ftn_addr) )
      {
       strcat(tm2echo," ");
       strcat(tm2echo,cword);
       lcnt++;
      }
     else
      uf=1;
    }

   cword=strtok(NULL," \t");
  }
 

 if ( lcnt == 0 ) return (3); 
 if ( uf==0 ) return (2);

 strcpy(echo,tm2echo);
 return(0);
}

RemoveLastLink(char *str)
{
 char ostr[MAXSTR+1];
 char *cword;

 log(5,"RemoveLastLink: instr '%s'",str);

 cword=strtok(str," \t");
 strcpy(ostr,cword);

 cword=strtok(NULL," \t");
 while ( cword != NULL )
  {

   if ( (isdigit(cword[0])) || (cword[0]=='.'))
    {
     log(5,"  %s removed",cword);
    }
   else
    {
     strcat(ostr," ");
     strcat(ostr,cword);
    }
        
   cword=strtok(NULL," \t");
  }

 strcpy(str,ostr);
 log(5,"RemoveLastLink: outstr '%s'",str);
}
 
