/* hasher.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Utility of automatic creation of   ⨫ ⮬᪮ ᮧ	⥩
 * some SqWish sources' parts.        室 SqWish'a.
 *
 * Reads files:     sqw-verb, sqw-area, sqw-reas		  ⠥ 䠩
 * Writes files:	sqw-cfg.h, sqw-cfg.c			    䠩
 *
 * sqw-verb - config words	      祢 ᫮ 䨣
 * sqw-area - non-echo areas	      -宮
 * sqw-reas - What Bad reasons	        ⠪ 뫮  ᮮ饭
 *
 * Additional functions:
 *
 * Checks pointer aryphmetic and     ஢ 䬥⨪ 㪠⥫  ⢥-
 * huge allocation of memory.	       ( 64) ࠧ஢ .
 *
 * Attempt  to	check  true work of  ⠥ । ॠ ࠡᯮ-
 * va_list components (used for de-   ⮢ va_list (ਬ 
 * bugging purposes in _debug.c, so  ⫠筮 㭪樨 _debug.c, ⠪   
 * is not actual for 'release' exe-  ஥ "⥫쭮" ᨨ  ᯮ-
 * cutable file building).	     塞 䠩 㠫쭮).
 *
 * --------------------------------  -----------------------------------------
 *           Check 'Daylight saving  ஢ઠ  ⭥ ६  䠩
 * bug' on file system: If  created  ⥬: ᫨ ६ ᮧ 䠩  ᤢ-
 * file has creation  time  shifted       ⭮⥫쭮  ॠ쭮
 * by one hour  in  comparison with  ६ ᮧ.
 * it's real creation time.
 *
 * Check byte order to be Intel.     ஢ઠ 浪 ⮢  ᫮.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include "./sqw-os.h"
#include "./sqw-tab.h"

int Rename_Test(void);
int Printf_HX_Test(void);
int IfIntCheck(void);
int DayLightCheck(void);
int ByteOrderCheck(void);

void PrintLine(void);
void WaitExit(void);

#if DEBUG

#include <stdarg.h>
void _debug2(char *, const char *,...);
void (*_debug(void))(char *, const char *,...);
int Va_Test(void);

void _debug2(char *buf, const char *format,...)
{
va_list va_ptr_here; int Nn = 0;
va_start(va_ptr_here, Nn);
vsprintf (buf, format, va_ptr_here);
va_end(va_ptr_here);
}

void (*_debug())(char *buf, const char *format,...)
{
return (void *)_debug2;
}

int Va_Test()
{
char Buf1[40], Buf2[40];
unsigned long Free_Memory = 123;
sprintf(Buf1,"Free = %lx", Free_Memory);
_debug()(Buf2,"Free = %lx", Free_Memory);
PrintLine();
printf ("Test  of  ANSI  va_list  components    ANSI  va_list (  ப\n");
printf ("(below two lines must be identical)      ):\n");
printf ("%s\n%s\n", Buf1, Buf2);
if (strcmp(Buf1,Buf2))
   {
   printf ("Lines are not identical  -  va_list   ப ⫨ - va_list   -\n");
   printf ("can't be  used  for  functions with   짮   㭪権    ६\n");
   printf ("variable number of arguments.         ᫮ 㬥⮢\n");
   }
else printf ("Lines are identical, va_list useful.  ப , va_list ᯮ㥬.\n");
return (strcmp(Buf1,Buf2));
}

#endif /* DEBUG */

void PrintLine()
{
printf ("-------------------------------------------------------------------------------\n");
}

void WaitExit()
{
fprintf (stderr, "Can't build SqWish properly in this    㤠 ᮡ SqWish  ⮩  ⨬\n");
fprintf (stderr, "OS by this compiler.                  । ⨬ ஬\n");
fprintf (stderr, "Press Enter>");
getchar();
exit(255);
}

#include "./_datefil.c"

char	rt[]="rt", wt[]="wt", wb[]="wb";

int DayLightCheck()
{
time_t t, u;

#ifdef __TURBOC__
struct ffblk ffbbk;
#endif

char fname[20] = "test.tmp";
FILE *f;

f = fopen(fname, wb);
if (f) fclose(f);
else	{
	printf ("Can't create temporary file!            ᮧ ६ 䠩!\n");
	return 0;
	}
time(&t);

#ifdef __TURBOC__
findfirst(fname, &ffbbk, 0);
u = date_from_file(&ffbbk);
#else
u = date_from_file(fname);
#endif

remove(fname);
if (((signed long)(u - t) < 20) && ((signed long)(t - u) < 20))
	{
	printf ("No file creation time difference.      ࠧ  ६ ᮧ 䠩.\n");
	return 0;
	}
else	{
	printf ("Different file creation time!          ᮧ  ᤢ  ६!\n");
	printf ("System time was:                       :          %s\n", ctime(&t));
	printf ("File time is:                         稫  䠫: %s\n", ctime(&u));
	printf ("If difference is near 1 hour - it's   ᫨ ࠧ  1  -   ");
	printf ("daylight saving...                    ⭥ ६ ⠪ 﫮...\n");
	}
return 1;
}

int ByteOrderCheck()
{
unsigned short int i = 0x0123;
char *c = (char *)(&i);
if ((*c == 0x23) && (c[1] == 0x01))
	{
	printf ("Intel bytes' order in short int.      ⥫᪨ 冷   ᫮.\n");
	return 0;
	}
else	{
	printf ("NOT Intel bytes' order in int!         ⥫᪨ 冷   ᫮!\n");
	}
return 1;
}

int IfIntCheck()
{
unsigned long l = 0x00010000L;
if (!l)
	{
	printf ("if (long == int) uses only low word!   襥 ᫮ !\n");
	return 1;
	}
else;
l = 0x00000001L;
if (!l)
	{
	printf ("if (long == int) uses only high!        !\n");
	return 1;
	}
else;
printf ("if (long == int) works properly...    ࠢ   ⪮ ࠡ⠥.\n");
return 0;
}
/*
 *  0 rename is destructive           २ ࠧ饥
 *  1 rename is non-destructive.      २ ࠧ饥
 * -1 Can't be tested.                   ஢
 */

int	retval0 = 0, retval1 = 0;

int Rename_Test()
{
char	rename_1[] = "rename.1",
	rename_2[] = "rename.2";
FILE *f;
struct stat st;

if ((f = fopen(rename_2,wb)) == NULL) goto Err1; else fclose(f);
retval0 = rename(rename_2,rename_1);
if ((f = fopen(rename_2,wb)) == NULL) goto Err1; else fclose(f);
retval1 = rename(rename_1, rename_2);
if ((!stat(rename_1, &st)) && (!stat(rename_2, &st)))
	{
	PrintLine();
	printf ("Rename is non-destructive.            २ ࠧ饥.\n");
	printf ("On success, returns:         %2i       頥  ᯥ\n", retval0);
	printf ("Unsuccess,  returns:         %2i       頥  㤠\n", retval1);
	unlink(rename_1);
	unlink(rename_2);
        PrintLine();
	return 1;
	}
else;
printf ("Rename is DESTRUCTIVE!                २ !\n");
unlink(rename_1);
unlink(rename_2);
return 0;
Err1:
printf ("Rename test: Can't create tmp files!    ᮧ ६ 䠩!\n");
return -1;
} /* Rename_Test */

/*
 * Maximum number of config verbs.    ᨬ쭮 ᫮ 権  䨣.
 */
#define MAXVERBS 300

/*
 * Function of hashing. 	      ⢥ 㭪 ஢.
 */

#define HASH_ADD(A,B) (((A << 2) + A + (B & 0x1F)) & 0x7FFF)
#define HASH_LINE "#define HASH_ADD(A,B) (((A << 2) + A + (B & 0x1F)) & 0x7FFF)\n"

char	Sqw_cfg_h[] = "sqw-cfg.h",
	Sqw_cfg_c[] = "sqw-cfg.c",
	Wbd_cfg[]   = "msg-wbd.cfg",
	Verbs[]     = "sqw-verb",
	Reasons[]   = "sqw-reas",
	Areas[]     = "sqw-area";

char	*Description, *Ext;

/****** ferror check on file opened; fclose;**********************************/
void ferfclose(char *filename, FILE *verbs)
{
if (ferror(verbs))
   {
   fprintf (stderr,"?hasher-F-I/O error on file: %s\n", filename);
   exit(1);
   }
else fclose(verbs);
}
/****** fopen, check error input file ****************************************/
FILE *fopener(char *filename)
{
FILE *verbs = fopen(filename, rt);
if (verbs == NULL)
   {
   fprintf (stderr, "?hasher-F-Can't open input file: %s\n", filename);
   exit(1);
   }
else;
return verbs;
}

void main()
{
FILE *verbs;
FILE *sqw_cfg_h = fopen(Sqw_cfg_h,wt);
FILE *sqw_cfg_c = fopen(Sqw_cfg_c,wt);

char tabchar[257], *TabChar = tabchar+1;

int i = 0, j = 0, Number, nline = 0;
unsigned char Line[256], *s0;
unsigned short int  Hash[MAXVERBS];
unsigned short int  Nline[MAXVERBS];

unsigned long Size = 256L*256L*4L+9, Counter;
unsigned long huge *Space;
unsigned long huge *Pointer;

fprintf(stderr,"hasher:\n");

PrintLine();
printf ("hasher.exe  -  programm tests  some   ணࠬ ஢  ᮢ-\n");
printf ("compiler/library incompatibilities,    /⥪, ⢥\n");
printf ("actual for SqWish and it's tools.      SqWish'a  ⨫  .\n");
PrintLine();

if (IfIntCheck()) WaitExit(); else;
if (ByteOrderCheck()) WaitExit(); else;
if (DayLightCheck()); else;

Pointer = Space = malloc(Size);

PrintLine();
if (Space)
	{
	printf ("Success: Space = malloc(262153);      ᯥ譮 ⢥ 262153  \n");
	printf ("Fill Space array with Counter...       Space 祭 Counter");
	*Pointer++ = 0; printf(".");
	*Pointer++ = 1; printf(".");
	*Pointer++ = 2; printf(".\n");
	for (Counter = 3; Counter < ((Size/sizeof(*Space)) - 1); Counter++)
		*Pointer++ = Counter;
	Pointer = Space;
	printf ("Compare Space filling with Counter.   ࠢ  Space c Counter\n");

	for (Counter = 0L; Counter < ((Size/sizeof(*Space)) - 1); Counter++)
	    if ((Counter != *Pointer) || (Counter != Space[Counter]))
		{
		printf ("Counter = %lu, Pointer = %p; (Space + (Counter * 4)) = %p\n",
			Counter, Pointer, Space + (Counter * sizeof(*Space)));
		if (Counter == 0L)
		   printf ("Pointer++ rolls to 0 after 64K.       ६ 㪠⥫ 頥  0\n");
		if (Counter != *Pointer)
		   printf ("Pointer++ logic error.                訡  ६஢ 稪.\n");
		if (Counter != Space[Counter])
		   printf ("Space[Counter] logic error.           訡  ᫥ ᬥ饭  ᨢ\n");
		printf ("Try another memory model or Compiler  ஡     ।\n");
		WaitExit();
		}
	    else Pointer++;
	printf ("Check Successfull. Counter = %lu    ஢ઠ 諠 ᯥ譮.\n", Counter);
	free(Space);
	}
else	{
	printf ("Can't allocate %lu bytes of memory  㤠 ⢥ ⮫쪮 !\n", Size);
	WaitExit();
	}

if ((sqw_cfg_h == NULL) || (sqw_cfg_c == NULL))
   {
   fprintf (stderr,"?hasher-F-Can't open output file[s]: %s %s\n",
	Sqw_cfg_h, Sqw_cfg_c);
   exit(1);
   }
else;

verbs = fopener(Verbs);

fputs ("/* sqw-cfg.h */\n",sqw_cfg_h);
fputs ("/* Created by hasher */\n",sqw_cfg_h);
fputs ("#ifndef SQW_CFG_H\n",sqw_cfg_h);
fputs ("#define SQW_CFG_H\n",sqw_cfg_h);
#if DEBUG
if (Va_Test()) fputs("#define VA_DISABLE\n",sqw_cfg_h); else;
#endif
if (Rename_Test()) fputs("#define RENAME_NONDESTRUCTIVE 1\n", sqw_cfg_h);
else fputs("#define RENAME_NONDESTRUCTIVE 0\n", sqw_cfg_h);
if (retval0 == retval1) fputs("#define RENAME_CHECKEXIST 1\n", sqw_cfg_h);
else {
     fputs("#define RENAME_CHECKEXIST 0\n", sqw_cfg_h);
     fprintf(sqw_cfg_h,"#define RENAME_SUCCESS %i\n", retval0);
     fprintf(sqw_cfg_h,"#define RENAME_ERROR %i\n", retval1);
     }
fputs (HASH_LINE,sqw_cfg_h);
fputs ("extern int Cfg[];\n",sqw_cfg_h);
fputs ("extern char *keywords[];\n",sqw_cfg_h);
fputs ("extern unsigned int  keyhashes[];\n",sqw_cfg_h);

fputs ("/* sqw-cfg.c */\n",sqw_cfg_c);
fputs ("/* Created by hasher */\n",sqw_cfg_c);
fputs ("#include \"./sqw-cfg.h\"\n",sqw_cfg_c);
fputs ("char *keywords[] =\n\t{\n",sqw_cfg_c);

while (fgets(Line,80,verbs))
	{
	nline++;
	s0 = Line;
	if (*s0 == ';') continue; else;
	Nline[i] = nline;
	Line[strlen(s0)-1] = '\0';
	if (Line[strlen(s0) - 2] == '\r') Line[strlen(s0) - 2] = '\0'; else;
	if (Line[strlen(s0) - 3] == '\r') Line[strlen(s0) - 3] = '\0'; else;
	Hash[i] = 0;
	while (*s0 != '\0') Hash[i] = HASH_ADD(Hash[i], *s0++);
	fprintf (sqw_cfg_h, "#define HASH_%s %u\n", Line, Hash[i]);
	fprintf (sqw_cfg_h, "#define Cfg_%s Cfg[%i]\n", Line, i);
	fprintf (sqw_cfg_h, "#define Key_%s %i\n", Line, i);
	fprintf (sqw_cfg_c, "\t\"%s\",\n", Line);
	i++;
	if (i > MAXVERBS)
		{
		fputs ("?hasher-F-Too many config verbs!\n", stderr);
		exit(1);
		}
	else;
	} /* while fgets */

Number = i;
fprintf (sqw_cfg_c, "\t\"\"\n\t};\n");
fprintf (sqw_cfg_c, "int Cfg[%i];\n", Number);
fprintf (sqw_cfg_h, "#define Cfg_Verbs_Num %i\n", Number);
fprintf (stderr, "%i config verbs; ", Number);
fputs ("unsigned int keyhashes[] =\n\t{\n",sqw_cfg_c);
for (i = 0; i < Number; i++)
	fprintf (sqw_cfg_c, "\t%u,\n", Hash[i]);
fprintf (sqw_cfg_c, "\t0 };\n");

for (i = 0; i < (Number-1); i++)
    for (j = i+1; j < Number ; j++)
	{
	if (Hash[i] == Hash[j])
	   {
	   fprintf (stderr, "?hasher-F-Identical hashes: line numbers %i %i\n", Nline[i], Nline[j]);
	   fprintf (stderr, "?hasher-F-Identical hashes: Change verbs...\n");
	   fclose(sqw_cfg_c);
	   fclose(sqw_cfg_h);
	   fclose(verbs);
	   remove ("sqw-cfg.h");
	   remove ("sqw-cfg.c");
	   exit (1);
	   } /* if Hash[i] == Hash[j] */
	} /* for j < Number */

ferfclose(Verbs, verbs);

/*****************************************************************************/
verbs = fopener(Reasons);
fprintf(sqw_cfg_h,"/* What Bad in message reasons definitions */\n");
fprintf(sqw_cfg_h,"extern unsigned char *wbd[], *wbd0[];\n");
fprintf(sqw_cfg_h,"enum what_bad_in_message\n\t{\n");
fprintf(sqw_cfg_c,"/* What Bad in message reasons descriptions */\n");
fprintf(sqw_cfg_c,"unsigned char *wbd[WBD_MAX+1], *wbd0[] =\n\t{\n");
i = 0;
while (fgets(Line,255,verbs))
	{
	s0 = Line;
	if (*s0 == ';') continue; else;

	while ((*s0 != ',') && (*s0 != '\0') && (*s0 != '\n')) s0++;
	if (*s0 != ',') continue; else;
	*s0++ = '\0';

	Description = s0;
	while ((*s0 != '\0') && (*s0 != '\n')) s0++;
	*s0 = '\0';
	fprintf(sqw_cfg_h,"\tWBD_%s,\n", Line);
	fprintf(sqw_cfg_c,"\t\"%s\",\n", Description);
	i++;
	}
fprintf(sqw_cfg_h,"\tWBD____\n\t};\n");
fprintf(sqw_cfg_c,"\t\"\"\n\t};\n");

fprintf (stderr, "%i What Bad reasons; ", i);
ferfclose(Reasons, verbs);

/*****************************************************************************/
verbs = fopener(Areas);
fprintf(sqw_cfg_h,"/* areas numbers definitions */\n");
fprintf(sqw_cfg_h,"extern unsigned char *Area_Desc[];\n");
fprintf(sqw_cfg_h,"enum area_numbers\n\t{\n");
fprintf(sqw_cfg_c,"/* non-echo areas descriptions */\n");
fprintf(sqw_cfg_c,"unsigned char *Area_Desc[] =\n\t{\n");
i = 0;
while(fgets(Line,256,verbs))
	{
	s0 = Line;
	if (*s0 == ';') continue; else;
	fprintf(sqw_cfg_h,"\tAREA%.3s,\n", s0);
	s0 += 7;
	Description = s0;

	while  ((*s0 != ';') && (*s0 != ',') &&
		(*s0 != '\0') && (*s0 != '\n')) s0++;
	*s0++ = '\0';

	fprintf(sqw_cfg_c,"\t\"%s\",\n",Description);
	i++;
	}
fprintf(sqw_cfg_h,"\tAREA___\n\t};\n");
fprintf(sqw_cfg_c,"\t\"\"\n\t};\n");

fprintf (stderr, "%i non-echo areas;\n", i);

rewind(verbs);

fprintf(sqw_cfg_h,"extern unsigned char *Ext[];\n");
fprintf(sqw_cfg_c,"/* .O?? files extentions */\n");
fprintf(sqw_cfg_c,"unsigned char *Ext[] =\n\t{\n");

while(fgets(Line,256,verbs))
	{
	s0 = Line;
	if (*s0 == ';') continue; else;
	fprintf (sqw_cfg_c,"\t\"~%c%c\",\n",toupper(s0[4]), toupper(s0[5]));
	}
fprintf(sqw_cfg_c,"\t\"\"\n\t};\n");

rewind(verbs);

fprintf(sqw_cfg_h,"extern unsigned char *sExt[];\n");
fprintf(sqw_cfg_c,"/* .O?? files extentions */\n");
fprintf(sqw_cfg_c,"unsigned char *sExt[] =\n\t{\n");

while(fgets(Line,256,verbs))
	{
	s0 = Line;
	if (*s0 == ';') continue; else;
	fprintf (sqw_cfg_c,"\t\"~%c%c\",\n",tolower(s0[4]), tolower(s0[5]));
	}
fprintf(sqw_cfg_c,"\t\"\"\n\t};\n");

ferfclose(Reasons, verbs);
/*****************************************************************************/

init_tab_char();

fputs ("/* table for Is*-macroses */\n",sqw_cfg_c);
fputs ("extern unsigned int tabchar[];\n",sqw_cfg_h);
fprintf (sqw_cfg_c, "unsigned int tabchar[257] =\n\t{\t%u", tabchar[0]);
for (i = 0; i < 16; i++)
    fprintf(sqw_cfg_c,
",\n\t%u, %u, %u, %u, %u, %u, %u, %u, %u, %u, %u, %u, %u, %u, %u, %u",
	TabChar[i*16], TabChar[i*16+1], TabChar[i*16+2], TabChar[i*16+3],
	TabChar[i*16+4], TabChar[i*16+5], TabChar[i*16+6], TabChar[i*16+7],
	TabChar[i*16+8], TabChar[i*16+9], TabChar[i*16+10], TabChar[i*16+11],
	TabChar[i*16+12], TabChar[i*16+13], TabChar[i*16+14], TabChar[i*16+15]
	);

fputs ("\n\t};\n/* EOF sqw-cfg.c */\n",sqw_cfg_c);
fputs ("\n#endif /* SQW_CFG_H */\n",sqw_cfg_h);
fputs ("/* EOF sqw-cfg.h */\n",sqw_cfg_h);

ferfclose("sqw-cfg.h", sqw_cfg_h);
ferfclose("sqw-cfg.c", sqw_cfg_c);

exit(0);
} /* main() */
