/* sqw-os.h * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * OS-aware definitions.	      -ᨬ ।.
 *
 */

#ifndef SQW_OS_H
#define SQW_OS_H

/*
 * Some important definitions here:    뭥ᥭ  ।:
 * Constants:			      ⠭:
 *
 * YOUR_COMPILER   Text description   ⮢ ᠭ /
 * YOUR_OS	 "os-aware prefix".   -ᨬ 䨪  ப 䨣
 * YOUR_OS_INCLUDE   "DOS*Include*"   -ᨬ 窠  Include 䨣
 *
 * BACKSLASH	     path delimiter   ࠧ⥫  
 * MAXPATH   maximum length of path   ᨬ쭠    䠩
 * MAXFNAME   maximum file name len   ᨬ쭠   䠩
 * MAXCMDLEN  batch/script line len   ᨬ쭠  ப ਯ⮢/.bat
 * LENNAME   name for created files     ᮧ 䠩
 * CREATEDIR created directory mask   ᪠ 㯠 ᮧ ४਩
 * (actual for UNIX, 0777 is debug)   (㠫쭮  UNIX, 0777 - ⫠筠)
 * SQW_RWFILE	read/write reg file   䠩  ⥭/
 *
 * 'fake' typedefs from TC 2.0/DOS:    "᫥⢨" TC 2.0/DOS:
 * far		       pointer type   ⨯ 㪠⥫, ⠫ ⮫쪮  TC2.0
 * huge 	       pointer type   ⨯ 㪠⥫, ⠫ ⮫쪮  TC2.0
 * S_IWRITE = S_IWUSR  write enable    ࠧ襭   䠩 (stat).
 * struct ffblk DOS file data block      䠩 .
 *
 * These 'main' parts are  used  by    ᭮ ࠬ, ࠤ  -
 * code calling  findfirst/findnext   뢠 㭪樨 findfirst/findnext  
 * functions or their replacements:   :
 *
 * struct ffblk {
    char ff_attrib;	    attribs   ਡ 䠩
    long ff_fsize;	  file size    㦥 䠩
    char *ff_name;}	  file name     ( ) 㦥 䠩
 *
 * Additional  parts of structure     ⥫  	   -
 * are used  by  replacements  of      㭪ﬨ, 騬 -
 * findfirst/findnext	functions     ᪨ findfirst/findnext,	  ७
 * for their internal purposes.       㦤  㭪権.
 *
 * See sqw-os.c for details.	      ஡ - . sqw-os.c.
 *
 * - - - - - - - - - - - - - - - -    - - - - - - - - - - - - - - - - - - - - -
 *
 * Macroses and functions:	        㭪樨:
 * farcoreleft()   free memory size    ⠢襩 ᢮ 
 * farmalloc()	== malloc()(!TC2.0)   , ஬ TC2.0 - malloc()
 * farfree()	== free()  (!TC2.0)   , ஬ TC2.0 - free()
 * fflushall()	   sync file system      
 * findfirst()	      DOS wildcards     䠩  ᪥
 * findnext()	      DOS wildcards     䠩  ᪥
 * MAKEDIR(A)	   create directory   ᮧ ४ਨ
 * IS_RWDIR(A)	 is path drw???????      ४ਥ  R/W?
 * SQW_O_EXCL open() file added bit   ⥫   ⨨ 䠩
 * Fname_cmp() are pathnames equal?     ப   ?
 * (w/o truename conversion)	      (  ஢ન truename)
 */

/******************** Check known OS/Compiler definitions ********************/
#if    defined(UNIX)
#elif  defined(DJGPP)
#elif  defined(__TURBOC__)
#elif  defined(__VC60__)
#elif  defined(__MSC60__)
#elif  defined(__EMX__)
#elif  defined(__WATCOMC__)
#elif  defined(__TOPSPEED__)

#else

#error ;Unknown Compiler/OS definition. Sorry, but something wrong!
#error ;Now valid platfroms/Compiler/OS definitions are:
#error ;UNIX	     - any (I hope) Unix system, Gnu C Compiler (plain C)
#error ;DJGPP	     - DJ Gnu C compiler (tested under MSDOS with CSWDPMI.EXE)
#error ;__TURBOC__   - Turbo C 2.0 compiler under MSDOS, Huge model required
#error ;__VC60__     - Microsoft Visual C 6.0 under Win32 console
#error ;__EMX__      - EMX compiler under OS/2
#error ;__WATCOMC__  - Watcom C

#error ;__MSC60__    - Microsoft C 6.0 (DOS)
#error ;__TOPSPEED__ - TopSpeed C 2.02e+ (DOS)

#endif

/******************** Check type sizes very needed for us ********************/
#include <limits.h>

#if (CHAR_BIT != 8)
#error char is not 8-bit type! Sorry, but I has no code for such situation...
#endif

#if (USHRT_MAX != 65535UL)
#error short int is not 16-bit type! Sorry, but I has no code for such situation...
#endif

#if (ULONG_MAX != 4294967295UL)
#error long int is not 32-bit type! Sorry, but I has no code for such situation...
#endif

/******************** OS/library/compiler - aware definitions ****************
Attention! function mkdir has  DIF-   ! 㭪 mkdir    
FERENT prototypes in different lib-    ࠧ /⥪! ஢-
raries/compilers. ;-( Check docume-     㬥樨  롥  ࠢ-
ntation and choose right variant.      ।.
******************************************************************************/

/**************************** WATCOM C DOS ***********************************/
#ifdef __WATCOMC__
  #define YOUR_COMPILER "WC/DOS"
  #define YOUR_OS "DOS"
  #define YOUR_OS_INCLUDE "DOS*Include*"

  #include <sys/stat.h>
  #include <malloc.h>
  #include <direct.h>
  #include <dos.h>
  #include <io.h>

  unsigned long date_from_file(char *);
  #define Date_from_file(A,B) date_from_file(A)
  #define MAKEDIR(A) mkdir(A)
  #define IS_RWDIR(A) (((A) & (S_IFDIR | S_IREAD)) == (S_IFDIR | S_IREAD))
  #define SQW_RWFILE (S_IFREG | S_IREAD | S_IWRITE)
  #define SQW_O_EXCL 0
  #define Fname_cmp(A,B) stricmp(A,B)

  #define BACKSLASH '\\'
  #define huge
  #define far

  #ifndef MAXPATH
    #define MAXPATH 128
  #endif
  #define MAXFNAME 14
  #define LENNAME   8
  #define MAXCMDLEN 128

  #define farmalloc(A) malloc((unsigned long)A)
  #define farfree(A) free((void *)A)
  #define malloc(A) malloc((unsigned long)A)
  #define free(A) free((void *)A)

/* ।  ப 㭪権  ⥬ ⨯ 㪠⥫ */
  #define strcpy(A,B) strcpy((char *)A,(char *)B)
  #define stricmp(A,B) stricmp((char *)A,(char *)B)
  #define strlen(A) strlen((char *)A)
  #define fgets(A,B,C) fgets((char *)A,(unsigned int)B,C)

/* ।   "" 㭪権 findfirst, findnext */
struct ffblk {
    char ff_attrib;	  /* attribute found */
    int  ff_ftime;	  /* file time */
    int  ff_fdate;	  /* file date */
    long ff_fsize;	  /* file size */
    char *ff_name;	  /* found file name */
    struct dirent *entry;
    DIR *dir;
    char fname[NAME_MAX];
};

int findfirst(const char *pathname, struct ffblk *ffblk, int attrib);
int findnext(struct ffblk *ffblk);

#endif

/****************************** Deja Gnu C under DOS (32 bit DPMI) ***********/
#ifdef DJGPP
#define YOUR_COMPILER "DJGPP/DPMI"
#define YOUR_OS "DOS"
#define YOUR_OS_INCLUDE "DOS*Include*"

#include <sys/stat.h>
#include <malloc.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <unistd.h>

#define Date_from_file(A,B) date_from_file(A)
unsigned long date_from_file(char *);
#define CREATEDIR 0777
#define MAKEDIR(A) mkdir(A,CREATEDIR)
#define IS_RWDIR(A) (S_ISDIR(A) && ((A) & S_IRUSR))
#define SQW_RWFILE (S_IRUSR | S_IWUSR)
#define SQW_O_EXCL 0
#define Fname_cmp(A,B) stricmp(A,B)

#define MAXPATH  80
#define MAXFNAME 14
#define LENNAME   8
#define MAXCMDLEN 128

#define huge
#define flushall() sync()

#define farmalloc(A) malloc((unsigned long)A)
#define farfree(A) free((void *)A)
unsigned long farcoreleft(void);
/* ।  ப 㭪権  ⥬ ⨯ 㪠⥫ */
#define BACKSLASH '\\'

#undef UNIX
#endif /* DJGPP */

/****************************** Turbo C 2.0, BC++3.1 Huge *******************/

#ifdef	__TURBOC__

#if (!defined(__HUGE__))
#error Sorry! Only Huge model may be used with TC 2.0 to compile SqWish!
#endif

#define short

#if (__TURBOC__ == 0x0200)
#define YOUR_COMPILER "TC2.0/Huge"
#elif (__TURBOC__ == 0x0301)
#define YOUR_COMPILER "BC3.1/Huge"
#else
#define YOUR_COMPILER "Borland/Huge"
#endif
#define YOUR_OS "DOS"
#define YOUR_OS_INCLUDE "DOS*Include*"

#include <sys/stat.h>
#include <alloc.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <process.h>

unsigned long date_from_file(struct ffblk *);
#define Date_from_file(A,B) date_from_file(B)
#define MAKEDIR(A) mkdir(A)
#define IS_RWDIR(A) (((A) & (S_IFDIR | S_IREAD)) == (S_IFDIR | S_IREAD))
#define SQW_RWFILE (S_IFREG | S_IREAD | S_IWRITE)
#define SQW_O_EXCL 0
#define Fname_cmp(A,B) stricmp(A,B)

#define MAXPATH  80
#define MAXFNAME 14
#define LENNAME   8
#define MAXCMDLEN 128

/* । 楤 ⢥    */
#define malloc(A) farmalloc((unsigned long)A)
#define free(A) farfree((void *)A)
#define farmalloc(A) farmalloc((unsigned long)A)
#define farfree(A) farfree((void *)A)
/* ।  ப 㭪権  ⥬ ⨯ 㪠⥫ */
#define strcpy(A,B) strcpy((char *)A,(char *)B)
#define stricmp(A,B) stricmp((char *)A,(char *)B)
#define strlen(A) strlen((char *)A)
#define fgets(A,B,C) fgets((char *)A,(unsigned int)B,C)
#define BACKSLASH '\\'

#define MSDOS __MSDOS__
#undef UNIX
#endif /* __TURBOC__ */

/****************************** TopSpeed 2.02e Huge **************************/

#ifdef	__TOPSPEED__

#if ((!defined(__FPTR)) || (!defined(__FDATA)))
#error Sorry! Only xLarge model may be used with TopSpeed to compile SqWish!
#endif

#define YOUR_COMPILER "TC2.0/Huge"
#define YOUR_OS "DOS"
#define YOUR_OS_INCLUDE "DOS*Include*"

#include <sys/stat.h>
#include <alloc.h>
#include <dir.h>
#include <dos.h>
#include <io.h>

unsigned long date_from_file(struct ffblk *);
#define Date_from_file(A,B) date_from_file(B)
#define MAKEDIR(A) mkdir(A)
#define IS_RWDIR(A) (((A) & (S_IFDIR | S_IREAD)) == (S_IFDIR | S_IREAD))
#define SQW_RWFILE (S_IFREG | S_IREAD | S_IWRITE)
#define SQW_O_EXCL 0
#define Fname_cmp(A,B) stricmp(A,B)

#define MAXPATH  80
#define MAXFNAME 14
#define LENNAME   8
#define MAXCMDLEN 128

/* । 楤 ⢥    */
#define malloc(A) halloc((unsigned long)(A))
#define free(A) hfree((void *)A)
#define farmalloc(A) halloc((unsigned long)(A))
#define farfree(A) hfree((void *)A)
/* ।  ப 㭪権  ⥬ ⨯ 㪠⥫ */
#define strcpy(A,B) strcpy((char *)A,(char *)B)
#define stricmp(A,B) stricmp((char *)A,(char *)B)
#define strlen(A) strlen((char *)A)
#define fgets(A,B,C) fgets((char *)A,(unsigned int)B,C)
#define BACKSLASH '\\'

#define MSDOS 1
#undef UNIX
#endif /* __TOPSPEED__ */

/*********************************** UNIX ************************************/
#ifdef UNIX

#include <sys/stat.h>

/* __EMX__ fixes by Netzah */

#ifdef __EMX__
#define YOUR_COMPILER "EMX"
#define YOUR_OS "OS2"
#define YOUR_OS_INCLUDE "OS2*Include*"
#include <sys/types.h>
#else
#define YOUR_COMPILER "UNIX/gcc"
#define YOUR_OS "UNIX"
#define YOUR_OS_INCLUDE "UNIX*Include*"
#endif

#include <dirent.h>

#ifdef __EMX__
#define MAXPATH MAXPATHLEN
#define MAXFNAME MAXPATHLEN
#endif

#include <unistd.h>
#include <syslog.h>

#ifndef NAME_MAX
#ifndef _STDIO_H
#include <stdio.h>
#endif
#define NAME_MAX FILENAME_MAX
#endif

unsigned long date_from_file(char *);
#define Date_from_file(A,B) date_from_file(A)
#define SQW_RWFILE (S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH)
#define SQW_O_EXCL O_EXCL
#define O_DENYNONE (S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP | S_IROTH | S_IWOTH)
#define O_DENYWRITE (S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH)
#define CREATEDIR (SQW_RWFILE | S_IXUSR | S_IXGRP | S_IXOTH)
#define MAKEDIR(A) mkdir(A,CREATEDIR)
#define Fname_cmp(A,B) strcmp(A,B)

/*
 * Detect if path is directory, and   ।,    ४ਥ,
 * we are allowed to read/write it.         /.
 */
#define IS_RWDIR(A) (S_ISDIR(A) && (((A) & (S_IRUSR | S_IWUSR)) == (S_IRUSR | S_IWUSR)))

/* ।   "" 㭪権 findfirst, findnext */
struct ffblk {
    char ff_attrib;	  /* attribute found */
    long ff_fsize;	  /* file size */
    char *ff_name;	  /* found file name */
    struct dirent *entry;
    DIR *dir;
    char fname[NAME_MAX];
};

int findfirst(const char *pathname, struct ffblk *ffblk, int attrib);
int findnext(struct ffblk *ffblk);
unsigned long farcoreleft(void);

#define huge
#define far

/* । 楤 ⢥   UNIX */
#define farmalloc(A) malloc((unsigned long)A)
#define farfree(A) free((void *)A)
#define malloc(A) malloc((unsigned long)A)
#define free(A) free((void *)A)

/* ।  㭪権 */
#ifndef __EMX__
#define stricmp strcasecmp
#define flushall sync
#endif

#define MAXCMDLEN 255
#define BACKSLASH '/'

#undef MSDOS
#endif
/*********************************** MacOs ***********************************/
#ifdef MACOS
#error MacOs definitions are not built yet... Sorry
#define YOUR_COMPILER "Unknown"
#define YOUR_OS "MAC"
#define YOUR_OS_INCLUDE "OS2*Include*"
#define BACKSLASH ':'
#define huge
#define far

#endif
/*********************************** OS/2 ************************************/
#ifdef OS2

#include <sys/stat.h>
#include <alloc.h>
#include <dir.h>

#define YOUR_COMPILER "Unknown"
#define YOUR_OS "OS2"
#define YOUR_OS_INCLUDE "OS2*Include*"

#define BACKSLASH '\\'
#define huge
#define far
#ifndef MAXPATH
#define MAXPATH  260
#endif
#define MAXFNAME 256
#define LENNAME  256
#define MAXCMDLEN 255
#define farmalloc(A) malloc((unsigned long)A)
#define farfree(A) free((void *)A)
#define malloc(A) malloc((unsigned long)A)
#define free(A) free((void *)A)

/* ।  ப 㭪権  ⥬ ⨯ 㪠⥫ */

#define strcpy(A,B) strcpy((char *)A,(char *)B)
#define stricmp(A,B) stricmp((char *)A,(char *)B)
#define strlen(A) strlen((char *)A)
#define fgets(A,B,C) fgets((char *)A,(unsigned int)B,C)

unsigned long date_from_file(char *);
#define Date_from_file(A,B) date_from_file(A)

#undef UNIX
#undef MSDOS
#endif

/****************************** Microsoft Visual C++ 6.0 Windows *************/
#ifdef __VC60__
#define YOUR_COMPILER "VC60/Win32/Console"
#define YOUR_OS "W32"
#define YOUR_OS_INCLUDE "W32*Include*"

#include <sys/stat.h>
#include <malloc.h>
#include <dos.h>
#include <io.h>

/* ।   "" 㭪権 findfirst, findnext */
struct ffblk {
    char ff_attrib;	  /* attribute found */
    long ff_fsize;	  /* file size */
    char *ff_name;	  /* found file name */
    unsigned long unixtime;
    long handle;
    struct _finddata_t fdata;
};

int findfirst(const char *pathname, struct ffblk *ffblk, int attrib);
int findnext(struct ffblk *ffblk);

#define Date_from_file(A,B) date_from_file(A)
unsigned long date_from_file(char *);
#define CREATEDIR 0777
#define MAKEDIR(A) mkdir(A,CREATEDIR)
#define IS_RWDIR(A) (((A) & (S_IFDIR | S_IREAD)) == (S_IFDIR | S_IREAD))
#define SQW_RWFILE (S_IFREG | S_IREAD | S_IWRITE)
#define SQW_O_EXCL 0
#define Fname_cmp(A,B) stricmp(A,B)
/*
 * It's enough for sqwarc.
 * It's NOT enough for any other usage!
 */
#define creatnew(path, param) _creat(path, _S_IREAD | _S_IWRITE);

#define MAXPATH  80
#define MAXFNAME 14
#define LENNAME   8
#define MAXCMDLEN 128

#define huge

#define farmalloc(A) malloc((unsigned long)A)
#define farfree(A) free((void *)A)
unsigned long farcoreleft(void);
#define BACKSLASH '\\'

#undef UNIX
#undef MSDOS
#endif /* __VC60__ */

/****************************** Microsoft C 6.0 DOS **************************/
#ifdef __MSC60__
#define YOUR_COMPILER "MSC60/DOS"
#define YOUR_OS "DOS"
#define YOUR_OS_INCLUDE "DOS*Include*"

#include <sys/types.h>
#include <sys/stat.h>
#include <malloc.h>
#include <dos.h>
#include <direct.h>
#include <io.h>

/* ।   "" 㭪権 findfirst, findnext */
struct ffblk {
    char ff_attrib;	  /* attribute found */
    long ff_fsize;	  /* file size */
    char *ff_name;	  /* found file name */
    unsigned long unixtime;
    long handle;
    struct find_t fdata;
};

int findfirst(const char *pathname, struct ffblk *ffblk, int attrib);
int findnext(struct ffblk *ffblk);

#define Date_from_file(A,B) date_from_file(A)
unsigned long date_from_file(char *);
#define MAKEDIR(A) mkdir(A)
#define IS_RWDIR(A) (((A) & (S_IFDIR | S_IREAD)) == (S_IFDIR | S_IREAD))
#define SQW_RWFILE (S_IFREG | S_IREAD | S_IWRITE)
#define SQW_O_EXCL 0
#define Fname_cmp(A,B) stricmp(A,B)

#define MAXPATH  80
#define MAXFNAME 14
#define LENNAME   8
#define MAXCMDLEN 128

#define farmalloc(A) halloc((unsigned long)(A), 1)
#define farfree(A) hfree((void *)A)
#define malloc(A) halloc((unsigned long)(A), 1)
#define free(A) hfree((void *)A)

unsigned long farcoreleft(void);
#define BACKSLASH '\\'

#undef UNIX
#endif /* __MSC60__ */

/************************** End of particular definitions ****************/

#ifndef YOUR_COMPILER
#define YOUR_COMPILER "Unknown"
#endif

#ifndef YOUR_OS
#define YOUR_OS "DOS"
#endif

#ifndef YOUR_OS_INCLUDE
#define YOUR_OS_INCLUDE "DOS*Include*"
#endif

/* ᫨  뫮 । MAXFNAME, MAXPATH -  䮫   */

#ifndef MAXFNAME
#ifdef FILENAME_MAX
#define MAXFNAME FILENAME_MAX
#else
#define MAXFNAME 14
#endif
#endif

#ifndef MAXPATH
#ifdef PATH_MAX
#define MAXPATH PATH_MAX
#else
#define MAXPATH 63
#endif
#endif

#ifndef S_IWRITE
#define S_IWRITE S_IWUSR
#endif

#ifndef Fname_cmp
#define Fname_cmp(A,B) stricmp(A,B)
#endif

/* ᫨  뫨 । O_DENY* -   UNIX'묨 ᪠          */
#ifndef O_DENYNONE
#define O_DENYNONE 0666
#endif
#ifndef O_DENYWRITE
#define O_DENYWRITE 0644
#endif

/* ᫨  뫮 । MAKEDIR -   䮫   DOS TC 2.0 */

#ifndef MAKEDIR
#define MAKEDIR(A) mkdir(A)
#endif

#endif /* SQW_OS_H */
