/* sqw-pc.c * Content-Type: TEXT/PLAIN; charset=cp866
 *
 * Path Correction procedure.	     ணࠬ ४樨 ⥩.
 *
 */

#include "./sqw-inc.h"

void Sqw_pc(char *);
char *Sqw_ph(char *);
char *sqw_ph(char *);

char *sqw_ph(char *s0)
{
static char s1[MAXPATH+3], *s2, *s3;

s3 = s2 = Sqw_ph(s0);
if (s2 == NULL) s2 = s0; else;
sprintf(s1, "%.*s", MAXPATH, s2);
if (s3) free(s3); else;
return s1;
}

/* ===========================================================================
 * Function  changes ~ to TildaHome   㭪  ~  砫   -
 * line  in  path.  Change only  if    TildaHome.
 * ~ is the first symbol in line.
 * If length == 0  -  leading tilda   ᫨  ⮩ ப == 0 - ⨫줠 -
 * disappears from path.	      .
 *
 * Always allocate new memory regi-   ᥣ ⢮     
 * on for changed line, even  if it   ப,  ᫨ 祣  﫮.
 * haven't been changed.
 * If summary path exceeds MAXPATH,   ᫨ 㬬ୠ   ॢᨫ
 * or if malloc error, returns NULL.  MAXPATH    墠⨫ - NULL.
 * ------------------------------------------------------------------------ */
char *Sqw_ph(char *s0)
{
char *s1;
#if (defined(UNIX) && (defined(Cfg_TildaHome)))
int len;

if (s0 == NULL) s0 = empty; else;
len = strlen(s0);
if ((*s0 == '~') && (Cfg_TildaHome))
   {
   if ((len + TildaHomeLen + 6) > MAXPATH) s1 = NULL;
   else s1 = malloc(len + TildaHomeLen + 6);
   if (s1) sprintf (s1, Format_ss, TildaHome, (s0 + 1)); else;
   } /* if (*s0 == '~') && Cfg_TildaHome */
else
   {
   s1 = malloc(len+6);
   if (s1) strcpy(s1,s0); else;
   }
#else

if (s0 == NULL) s0 = empty; else;
s1 = malloc((strlen(s0) + 6));
if (s1) strcpy(s1,s0); else;

#endif /* (defined(UNIX) && (defined(Cfg_TildaHome))) */
return s1;
}
/* ============================================================================
 * Adds BACKSLASH to the path if      㭪     
 * there is no BACKSLASH.	᫨   .

Empty  path  does NOT  receive \ as  ⮩     ᫥襬
alone symbol.

Assumes memory allocated for string  ,  ⢥񭭠  ப 
is really more than it's strlen!      ᠬ  , 祬  !

-----------------------------------------------------------------------------*/
void Sqw_pc (char *s0)
{
char *s1 = s0;
while (*s1 != '\0') s1++;
if (s1 != s0)
   if (*--s1 != BACKSLASH)
      {
      *++s1 = BACKSLASH;
      *++s1 = '\0';
      }
   else;
else;
}
