/* sqwarcx.c * Content-Type: TEXT/PLAIN; charset=cp866
 * (C) 1998 Sergej Qkowlew     2:5020/122@fidonet		 ࣥ 
 *
 *			       V03.06
 *
 * = V03.05 =======================  ==========================================
 * -p switch added - paranoia.	      ࠭ ᢨ -p
 * -o switch - where to place PKT     ᢨ -o 㤠 ६ PKT
 *	       after unpacking. 			    ᫥ ᯠ.
 * -m switch - move command	      ᢨ -  move
 * = V03.00 =======================  ==========================================
 * Make executable under UNIX:	     cc -DUNIX -o sqwarcx sqwarcx.c
 * Sample DOS executables building - see make_dos.bat
 *
 * Tool for unpacking inbound files   ணࠬ ᯠ 室 બ  
 * with using rules in	squish-like   ਬ ࠢ  ᪢订	䠩 
 * file compress.cfg.		      ᠭﬨ 娢஢ - compress.cfg.
 *
 * Keeps .pkt from overwriting with   ࠭ 㦥 騥 䠩 .pkt  -
 * unpacked from arcmail  files  by   १뢠 묨 ᯠ뢠묨  
 * renaming   them  temporarily  to   બ  ६ २
 * .#kt and then -  renaming  back.    .#kt  ⭮ २.
 *
 * Unpacks files in CURRENT dir.      ᯠ뢠 䠩  ⥪ ४.
 *
 * Distribution:		      ᮡ ࠭:
 * Source code under GNU license.      室 ⥪,  ࠬ GNU.
 *
 * This  program  is free software;    ணࠬ  ᢮ -
 * you	can  redistribute it and/or   ࠭塞 ணࠬ ᯥ祭;  -
 * modify  it  under  the  terms of    ஢ /  ஢  
 * the GNU General  Public  License    ᮮ⢥⢨  ᥮騬   -
 * as published by the Free Softwa-   襭 GNU ( FSD),  ᨨ, -
 * re Foundation;  either version 2   稭  2.
 * of the  License,  or  any  later
 * version.
 *
 * This program is  distributed  in    ணࠬ ࠭  ,
 * the hope that it will be useful,      ,    -
 * but WITHOUT ANY  WARRANTY; with-    ;      ࠭⨩ ⮣,
 * out even the implied warranty of      த,    ᢮⢠
 * MERCHANTABILITY or FITNESS FOR A   ᮮ⢥ ⭮ ਬ. 
 * PARTICULAR PURPOSE. See the	GNU   ᭥ ⠫ ⠩ ᥮饥 -
 * General Public License for  more    襭 GNU.
 * details.		       (file 'copying' in this package)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include "./sqw-os.h"  /* OS-aware definitions from SQWISH sources (V02.15+) */

#if (!defined(SQWARCX_ALONE))
#include "./sqw-cfg.h"
int	Cfg[Cfg_Verbs_Num];
#endif

#if (defined(__TURBOC__) || defined(DJGPP) || defined(__VC60__) || defined(__MSC60__))
#include <process.h>
#endif

#ifdef UNIX
#include <sys/types.h>
#include <sys/wait.h>
#endif

#define MAXARGS 200	/* ᨬ쭮 ⢮ 㬥⮢ argv[]	    */
#define ARCMAX 40	/* ᨬ쭮 㥬 ᫮ 娢஢	    */
#define MAXLINE 4096	/* ᨬ쭠  ப 䨣 compress.cfg   */
#define LENEXT 3	/*  ७ 䠩 (᫥ ᫥ 窨)   */

static char	*compress_cfg = NULL,			/*  䨣	    */
		rb[] = "rb", at[] = "at", rt[] = "rt";  /* ਡ fopen   */
static char	x_pkt[] = "*.pkt", x_xkt[] = "*.#kt";   /* renaming masks   */
static char	your_os[] = YOUR_OS;
static char	Format_ss[] = "%s%s";
static char	Cant_Rename[] = "Can't rename";
static char	Cant_Remove[] = "Can't remove";
static char	Format_s_s_errno_i[] = "%s %s; errno = %i";

static char	*mask[] = {		/* ᪨ 䠩, ਭ  */
			"????????.mo?", /* બ                */
			"????????.tu?",
			"????????.we?",
			"????????.th?",
			"????????.fr?",
			"????????.sa?",
			"????????.su?",
			NULL		/* ਧ 砭 ᯨ᪠ ᮪   */
			  };
static struct ffblk f;			/*   findfirst/next     */
					/*  ᬮ બ	    */

static int  ZeroLength = 0;		/* -z option storing here	    */
static char *tossing_log = NULL;	/*    䠩 	    */
static char *InBound = "";              /*   室 䠩            */
static char *arcpath = "";              /*   娢ࠬ  ࠭  */
static char *outpath = NULL;		/* 㤠 ६ ⮣ PKT     */
#ifdef UNIX
static char *movecmd = "mv";
#else
static char *movecmd = "move";
#endif
static int  paranoia = 0;
static char empty[] = "";

static char Buffer[MAXLINE+2],
	    Line[MAXLINE+2]; /*  ப    䠩 ଠ樨 */

#if 0
/*  १ ࠡ⪨ compress.cfg ࠧ : - - - - - - - - - */
static unsigned int  Num_Arcs;		/* ᪮쪮 稫 娢஢   */
static		long Offset[ARCMAX];	/* 饭  Ident		    */
static unsigned long Length[ARCMAX];	/*  ᫥⥫쭮 ⮢  */
static unsigned char *Ident[ARCMAX];	/*  ᫥⥫쭮 ⮢   */
#endif /* 0 */

/* =========== ⨯   㭪権 =========================== */
int strcasecmp_match(char *, char *);	/*  㭪樨 ࠢ  wildcards  */
void RenamePKT(char *, char *); 	/* २  䠩	    */
void MovePKT(char *);			/* Move *.pkt to outpath	    */
void DelPKT(void);			/* Delete *.pkt in current dir	    */
void OutLog(char *);			/* 뢮 ப  /syslog	    */
void ArcMailError(char *, char *, int); /* २  બ	    */
int  System(char **);			/* 맮 ⥬ 	    */
int	Read_Compress_Cfg(char *, char *, char *);
char  **From_Compress_Cfg(char *, char *, char *);

#include "./_compres.c"
/* ===========  ணࠬ ========================================== */

void main (int argc, char *argv[])
{
#if (defined(__TURBOC__))
short int dummy;	/* 窠 ⨢  ࡮- 2.0		    */
#endif
register int i; 	/* 稪 直				    */
int	k;
static	char **args;			/* ப  execvp/spawnvp	    */

/* - - - - - - ⢥ ᯮ塞  - - - - - - - - - - - - - - - - - */
/* ======================= Command Line help ============================== */
if (argc == 1)	{
		printf ("SqWarcx V03.06/%s (C) Sergej Qkowlew 2:5020/122\n\n", YOUR_COMPILER);

		puts ("Under GNU Public License");
		puts ("Arcmail unpacker SqWish-style with compress.cfg using. KEEPS .pkt files with");
		puts ("identical filenames from overwriting from arcmail by properly pre-renaming.\n");

		puts ("Switches (possible spaces between switch and parameter):\n");

#ifdef UNIX
		puts ("-c/fido/compress.cfg\t- config file setting");
		puts ("-n/fido/log/tossing.log\t- log file (if no - syslog is used)");
		puts ("-p/usr/bin/\t\t- paranoia. No search executables in PATH");
		puts ("-iinbound/\t\t- inbound path WITH last '/' (if no - current dir)");
		puts ("-ooutpath/\t\t- where to place correctly unpacked PKT");
#else
		puts ("-ck:\\compress.cfg\t- config file setting");
		puts ("-nk:\\tossing.log\t- log file");
		puts ("-pc:\\arc\\\t\t- paranoia. No search executables in PATH");
		puts ("-iinbound\\\t\t- inbound path WITH last '\\' (if no - current dir)");
		puts ("-ooutpath\\\t\t- where to place correctly unpacked PKT");
#endif
		puts ("-z\t\t\t- Ignore zero-length arcmails");

		puts ("\nErrorlevels:\n");

		puts ("0 - successfull work                      1 - some parametres missing or wrong");
		puts ("2 - can't open or read error config file  3 - can't open or append log file");
		puts ("4 - No archivers defined in compress.cfg  5 - some inbound files cannot be read");
		puts ("7 - Not enough memory for some data, or too many archivers defined");
		puts ("8 - Too long path or command line encountered when calling ext. programms");
#ifdef __TURBOC__
		printf("%lu bytes available memory\n", farcoreleft());
#endif
		exit (1);
		}
else
/* ======================= Command Line analysing ======================== */
   for (i = 1; i < argc; i++)
	{ char *s0 = argv[i];
	if (*s0++ == '-')
	   switch(toupper(*s0++))
		{
		case 'Z': ZeroLength = 1; break;

#define Pkey(A,B) case A: if (*s0 == '\0') if (++i == argc) break; \
	else s0 = argv[i]; else; B = s0;

	   Pkey('P', arcpath); paranoia = 1; break;
	   Pkey('I', InBound); break;
	   Pkey('C', compress_cfg); break;
	   Pkey('O', outpath); break;
#if TOSSING_LOG
	   Pkey('N', tossing_log); break;
#endif
#undef Pkey
		default:;
		} /* switch toupper(*s0) */
	} /* for i < argc */

if (!Read_Compress_Cfg("Extract", arcpath, compress_cfg)) exit(2); else;

/* ======================= Inbound files reading ========================= */
RenamePKT(x_pkt, x_xkt);	       /* २ 訥 .pkt */
i = 0;
do  { /* while mask[++i] != NULL */		/* 横 ॡ ᮪  */
    sprintf (Line, Format_ss, InBound, mask[i]);
    if (!findfirst(Line, &f, 0))		/* 横 ॡ બ  */
						/*  ⭮ ᪨     */
     do {
	sprintf(Line, Format_ss, InBound, f.ff_name); /*    Line    */
/* + V03.00 */
	if (ZeroLength && (f.ff_fsize == 0L))
		{
#if DEBUG
		sprintf (Buffer, "Zero-length file %s\n", Line);
		OutLog(Buffer);
#endif
		continue;
		}
	else;
/* - V03.00 */
	if ((args = From_Compress_Cfg(Line,empty,x_pkt)) != NULL)
	   {
	   k = System(args);
	   if(k){
		ArcMailError(Line, "Bad arcmail", i);
		if (outpath) DelPKT(); else;
		}
	   else {
		if (outpath) MovePKT(Line); else;
		if (remove(Line))
		   {
		   sprintf (Buffer, Format_s_s_errno_i,
			   Cant_Remove, Line, errno);
		   OutLog(Buffer);
		   }
		else;
		}
	   } /* if args */
	else	ArcMailError(Line, "Bad or unrecognized arcmail", i);
	}
     while (!findnext(&f));
    else;
    }
while (mask[++i] != NULL);
RenamePKT(x_xkt, x_pkt);
exit(0);
} /* main() */

/* ======================================================================== */

static struct ffblk f1;
static struct ffblk f2;
static char newname[20];

void RenamePKT(char *oldmask, char *newmask)
{
char *newext = newmask+2, *s0;
time_t ttt;

time(&ttt);
if (!findfirst(oldmask,&f1,0))
   do	{
	strcpy(newname, f1.ff_name);
	s0 = newname;
	while (*s0 != '.') s0++; s0++;
	strcpy(s0, newext);
	while (!findfirst(newname, &f2, 0) && ++ttt)	/*   */
	   sprintf(newname,"%8.8lx.%s", (unsigned long)ttt, newext);
#if DEBUG
/**/printf ("oldname = \"%s\"; newname = \"%s\"\n", f1.ff_name, newname);
#endif
	if (ttt && !rename(f1.ff_name, newname))    /* ᯥ譮 २ */
		continue;
	else	OutLog(Cant_Rename);
	}
   while(!findnext(&f1));
} /* RenamePKT() */

/* ============ Move correctly unpacked PKT files to outpath ============== */
void MovePKT(char *line)
{
char *args[MAXARGS];
struct	ffblk f;
#ifdef UNIX
int k;
#endif
time_t ttt;
char	newpath[MAXPATH+1], *s0;
time(&ttt);
if (!findfirst(x_pkt,&f,0))
   do	{
	sprintf(newpath, Format_ss, outpath, f.ff_name);
	s0 = newpath + strlen(outpath);
	while(*s0 != '.') s0++; s0++;
#if (defined(UNIX) && (!defined(__EMX__)))
	while ((k = link(f.ff_name, newpath)) != 0)
	   if (errno == EEXIST)
	      sprintf(newpath, "%s%8.8lx.pkt", outpath, (unsigned long)ttt++);
	   else if ((errno == EXDEV) || (errno == EPERM))
		   {
		   args[0] = movecmd; args[1] = f.ff_name;
		   args[2] = newpath; args[3] = NULL;
		   System(args);
		   break;
		   }
		else break;
	if (!k) unlink(f.ff_name);	/* success link - unlink old */
	else;
#else
	while (rename(f.ff_name, newpath))
	   if (errno == EACCES)
		sprintf(newpath, "%s%8.8lx.pkt", outpath, (unsigned long)ttt++);
	   else
#ifdef ENOTSAM /* Visual C++ has NO such errno returned on rename */
		 if (errno != ENOTSAM) break;
		 else
#endif /* ENOTSAM */
		   {
		   args[0] = movecmd; args[1] = f.ff_name;
		   args[2] = newpath; args[3] = NULL;
		   System(args);
		   break;
		   }
#endif
	}
   while(!findnext(&f));
else	{
	sprintf (Buffer, "Strange. No *.pkt unpacked from %s", line);
	OutLog (Buffer);
	}
}/* MovePKT() */

/* ============ Delete incorrectly unpacked PKT files in current dir ====== */
void DelPKT()
{
struct	ffblk f;
int Error_Delete = 0;

if (!findfirst(x_pkt,&f, 0))
   do	if (remove(f.ff_name)) Error_Delete++; else;
   while (!findnext(&f));
else;
if (Error_Delete)
   {
   sprintf(Buffer,Format_s_s_errno_i, Cant_Remove, x_pkt, errno);
   OutLog(Buffer);
   }
else;
} /* DelPKT() */
/* ============ Rename bad arcmail and log about it ======================= */
void ArcMailError(char *path, char *message, int i)
{
char tmp[MAXLINE+1], *s0;

#if DEBUG
sprintf (tmp, "%s %s; errno = %i; %s\n",
	message, path, errno, strerror(errno));
#else
sprintf (tmp, Format_s_s_errno_i, message, path, errno);
#endif
OutLog(tmp);
strcpy(Buffer, path);		/*  २뢠	     */
s0 = Buffer + strlen(Buffer) - LENEXT;
*s0++ = 'B'; *s0++ = (char)(i + '0');
while (rename(path, Buffer))	/* 横 ᪠  २ */
    if (*s0 >= 'Z')
	{
#if DEBUG
	sprintf (tmp, "%s %s to %s; errno = %i; %s",
			Cant_Rename, path, Buffer, errno, strerror(errno));
#else
	sprintf (tmp, Format_s_s_errno_i, Cant_Rename, path, errno);
#endif
	OutLog(tmp);
	break;
	}
    else if (*s0 == '9') *s0 = 'A';
	 else (*s0)++;
} /* ArcMailError */

/* ============ Restricted OutLog ========================================= *
 * Open log, write lline to it	and   뢠 ,    ப  -
 * close log. If open error encoun-   뢠 . ᫨  㤠    -
 * tered - reroute to SysLog servi-   ७ࠢ  SysLog (᫨ ),
 * ce (if it's possible) or stderr,     stderr,   ࢮ ⠪ -
 * on the first error  notes  about    ᮮ頥,  ᫥ - .
 * this error, other errors of ope-
 * ning log file are not reported.
 * ------------------------------------------------------------------------ */
void OutLog(char *lline)
{
FILE *filelog;
static int Log_Error = 0;	/* Flag of error opening log encountered    */
char *timeline; 		/* Pointer to corrected line with time	    */
int i;				/* Counter for any purposes		    */
time_t timer[1];		/* structure to keep current time	    */

time(timer);			/* Get current unixtime 		    */
timeline = ctime (timer);	/* Convert it to ascii form		    */

timeline[0]=' ';
timeline[1]=timeline[8];
timeline[2]=timeline[9];
for (i=8; i <= 16; i++)
    timeline[i]=timeline[i+3];
timeline[17]='\0';
				/* now 'Bink-style' log time is in timeline */
if (tossing_log)
   {
   if ((filelog = fopen (tossing_log, at)) == NULL)
      {
#ifdef HAVE_SYSLOG
      openlog ("sqwarcx", LOG_PID | LOG_CONS, LOG_USER);
      if (!Log_Error) syslog (LOG_INFO,
	"Can't open log `%s', rerouted to syslog", tossing_log);
      else;
#else
      filelog = stderr;
      if (!Log_Error)
	 fprintf (filelog,
	    "!%.19sARCX Can't open log `%s', rerouted to stderr\n",
	    timeline, tossing_log);
      else;
#endif
      Log_Error = 1;
      } /* if (filelog == NULL) */
   else;
   } /* if (tossing_log) */
else
#ifdef HAVE_SYSLOG
    openlog ("sqwarcx", LOG_PID | LOG_CONS, LOG_USER);
#else
    filelog = stderr;
#endif

#ifdef HAVE_SYSLOG
  if (filelog == NULL || filelog == stderr)
    syslog (LOG_INFO, "%s", lline);
/*
 *  ࠭ 뫮 syslog(LOG_INFO, lline);
 *  ࠭...    䠩    㣮... ;-)
 */
  else
#endif
    fprintf (filelog, "!%.19sARCX %s\n", timeline, lline);

  if (filelog && (filelog != stderr))
    fclose (filelog);
#ifdef HAVE_SYSLOG
  else
    closelog ();
#endif
} /* OutLog() */

/* ======================= Call externals ================================= */
int System(char **args)
{
int k=0;
int Sum=0;
while(args[k])
     {
     Sum += strlen(args[k]);
     if ((strlen(args[k]) > MAXPATH) || (Sum > MAXCMDLEN))
	{
#if DEBUG
	printf("Too long path %s(%i) or entire command line (%i)\n", args[k],
		strlen(args[k]), Sum);
#endif
	exit(8);
	}
     else
	{
#if DEBUG
	printf("%s ", args[k]);
#endif
	k++;
	}
     }

#ifdef UNIX
if(fork())
     {			     /* த⥫ ...	  */
     wait(&k);
     k = WEXITSTATUS(k);     /* 稫  	  */
     }
else {			     /* ॡ񭮪 ᯮ  */
     if (paranoia) execv(args[0], args);
     else execvp(args[0], args);
     exit(6);		     /*  稫 ᯮ   */
     }
#else
if (paranoia) k = spawnv(P_WAIT, args[0], args);
else k = spawnvp(P_WAIT, args[0], args);
#endif
return k;
} /* System */

#include "./_match.c"

#if (defined(SQWARCX_ALONE))

#ifdef UNIX
/*
 * This is module for UNIX version.       ᨨ  SqWish   UNIX.
 * There is definition of DOS func-        ।   ᪨	㭪樨
 * tions  findfirst/findnext  under   findfirst/findnext  UNIX.
 * UNIX.
 *
 * Copyright (C) 1997 Ivan Munitsin, 2:5020/418 		    㭨
 */

#include <unistd.h>

int findfirst(const char *pathname, struct ffblk *ffblk, int attrib) {
char *pos;
struct stat buf;
char findpath[NAME_MAX];

   strcpy(findpath, pathname);
   if ((pos=(char *)strrchr(findpath, '/'))==NULL) {
      strcpy(ffblk->fname, findpath);
      strcpy(findpath, ".");
   }
   else {
      strcpy(ffblk->fname, pos+1);
      *pos='\0';
   }

   ffblk->dir=opendir(findpath);
   while ((ffblk->entry=readdir(ffblk->dir))!=NULL) {
      if (strcasecmp_match(ffblk->entry->d_name, ffblk->fname) == 0) {
	 ffblk->ff_name=ffblk->entry->d_name;
	 stat(ffblk->ff_name, &buf);
	 ffblk->ff_fsize=buf.st_size;
	 return 0;
      }
   }
   closedir(ffblk->dir);
   return -1;
}

int findnext(struct ffblk *ffblk) {
struct stat buf;

   while ((ffblk->entry=readdir(ffblk->dir))!=NULL) {
      if (strcasecmp_match(ffblk->entry->d_name, ffblk->fname) == 0) {
	 ffblk->ff_name=ffblk->entry->d_name;
	 stat(ffblk->ff_name, &buf);
	 ffblk->ff_fsize=buf.st_size;
	 return 0;
      }
   }
   closedir(ffblk->dir);
   return -1;
}
#endif /* fdef UNIX */
#endif /* ndef SQWARCX_ALONE */
/* EOF sqwarcx.c */
